diff --git a/src/backend/commands/tablecmds.c b/src/backend/commands/tablecmds.c
index f976c0e5c7e..8cdfea1ccfb 100644
--- a/src/backend/commands/tablecmds.c
+++ b/src/backend/commands/tablecmds.c
@@ -3647,6 +3647,7 @@ SetRelationHasSubclass(Oid relationId, bool relhassubclass)
 	Relation	relationRelation;
 	HeapTuple	tuple;
 	Form_pg_class classtuple;
+	Bitmapset  *updated = NULL;
 
 	Assert(CheckRelationOidLockedByMe(relationId,
 									  ShareUpdateExclusiveLock, false) ||
@@ -3664,8 +3665,8 @@ SetRelationHasSubclass(Oid relationId, bool relhassubclass)
 
 	if (classtuple->relhassubclass != relhassubclass)
 	{
-		classtuple->relhassubclass = relhassubclass;
-		CatalogTupleUpdate(relationRelation, &tuple->t_self, tuple);
+		HeapTupleUpdateField(pg_class, relhassubclass, relhassubclass, classtuple, updated);
+		CatalogTupleUpdate(relationRelation, &tuple->t_self, tuple, updated, NULL);
 	}
 	else
 	{
@@ -3674,6 +3675,7 @@ SetRelationHasSubclass(Oid relationId, bool relhassubclass)
 	}
 
 	heap_freetuple(tuple);
+	bms_free(updated);
 	table_close(relationRelation, RowExclusiveLock);
 }
 
@@ -3753,6 +3755,8 @@ SetRelationTableSpace(Relation rel,
 	HeapTuple	tuple;
 	ItemPointerData otid;
 	Form_pg_class rd_rel;
+	Bitmapset  *updated = NULL;
+	Oid			field = InvalidOid;
 	Oid			reloid = RelationGetRelid(rel);
 
 	Assert(CheckRelationTableSpaceMove(rel, newTableSpaceId));
@@ -3767,11 +3771,16 @@ SetRelationTableSpace(Relation rel,
 	rd_rel = (Form_pg_class) GETSTRUCT(tuple);
 
 	/* Update the pg_class row. */
-	rd_rel->reltablespace = (newTableSpaceId == MyDatabaseTableSpace) ?
-		InvalidOid : newTableSpaceId;
+	if (newTableSpaceId != MyDatabaseTableSpace)
+		field = newTableSpaceId;
+
+	HeapTupleUpdateField(pg_class, reltablespace, field, rd_rel, updated);
+
 	if (RelFileNumberIsValid(newRelFilenumber))
-		rd_rel->relfilenode = newRelFilenumber;
-	CatalogTupleUpdate(pg_class, &otid, tuple);
+		HeapTupleUpdateField(pg_class, relfilenode, newRelFilenumber, rd_rel, updated);
+
+	CatalogTupleUpdate(pg_class, &otid, tuple, updated, NULL);
+
 	UnlockTuple(pg_class, &otid, InplaceUpdateTupleLock);
 
 	/*
@@ -3783,6 +3792,7 @@ SetRelationTableSpace(Relation rel,
 									 rd_rel->reltablespace);
 
 	heap_freetuple(tuple);
+	bms_free(updated);
 	table_close(pg_class, RowExclusiveLock);
 }
 
@@ -3852,6 +3862,7 @@ renameatt_internal(Oid myrelid,
 	HeapTuple	atttup;
 	Form_pg_attribute attform;
 	AttrNumber	attnum;
+	Bitmapset  *updated = NULL;
 
 	/*
 	 * Grab an exclusive lock on the target table, which we will NOT release
@@ -3965,9 +3976,10 @@ renameatt_internal(Oid myrelid,
 	(void) check_for_column_name_collision(targetrelation, newattname, false);
 
 	/* apply the update */
-	namestrcpy(&(attform->attname), newattname);
-
-	CatalogTupleUpdate(attrelation, &atttup->t_self, atttup);
+	namestrcpy(&attform->attname, newattname);
+	HeapTupleMarkColumnUpdated(pg_attribute, attname, updated);
+	CatalogTupleUpdate(attrelation, &atttup->t_self, atttup, updated, NULL);
+	bms_free(updated);
 
 	InvokeObjectPostAlterHook(RelationRelationId, myrelid, attnum);
 
@@ -4273,6 +4285,7 @@ RenameRelationInternal(Oid myrelid, const char *newrelname, bool is_internal, bo
 	HeapTuple	reltup;
 	Form_pg_class relform;
 	Oid			namespaceId;
+	Bitmapset  *updated = NULL;
 
 	/*
 	 * Grab a lock on the target relation, which we will NOT release until end
@@ -4318,9 +4331,12 @@ RenameRelationInternal(Oid myrelid, const char *newrelname, bool is_internal, bo
 	 * Update pg_class tuple with new relname.  (Scribbling on reltup is OK
 	 * because it's a copy...)
 	 */
-	namestrcpy(&(relform->relname), newrelname);
 
-	CatalogTupleUpdate(relrelation, &otid, reltup);
+	namestrcpy(&relform->relname, newrelname);
+	HeapTupleMarkColumnUpdated(pg_class, relname, updated);
+	CatalogTupleUpdate(relrelation, &otid, reltup, updated, NULL);
+	bms_free(updated);
+
 	UnlockTuple(relrelation, &otid, InplaceUpdateTupleLock);
 
 	InvokeObjectPostAlterHookArg(RelationRelationId, myrelid, 0,
@@ -4363,6 +4379,7 @@ ResetRelRewrite(Oid myrelid)
 	Relation	relrelation;	/* for RELATION relation */
 	HeapTuple	reltup;
 	Form_pg_class relform;
+	Bitmapset  *updated = NULL;
 
 	/*
 	 * Find relation's pg_class tuple.
@@ -4374,13 +4391,11 @@ ResetRelRewrite(Oid myrelid)
 		elog(ERROR, "cache lookup failed for relation %u", myrelid);
 	relform = (Form_pg_class) GETSTRUCT(reltup);
 
-	/*
-	 * Update pg_class tuple.
-	 */
-	relform->relrewrite = InvalidOid;
-
-	CatalogTupleUpdate(relrelation, &reltup->t_self, reltup);
+	/* Update pg_class tuple */
+	HeapTupleUpdateField(pg_class, relrewrite, InvalidOid, relform, updated);
+	CatalogTupleUpdate(relrelation, &reltup->t_self, reltup, updated, NULL);
 
+	bms_free(updated);
 	heap_freetuple(reltup);
 	table_close(relrelation, RowExclusiveLock);
 }
@@ -7264,6 +7279,7 @@ ATExecAddColumn(List **wqueue, AlteredTableInfo *tab, Relation rel,
 	AlterTableCmd *childcmd;
 	ObjectAddress address;
 	TupleDesc	tupdesc;
+	Bitmapset  *updated = NULL;
 
 	/* since this function recurses, it could be driven to stack overflow */
 	check_stack_depth();
@@ -7323,8 +7339,13 @@ ATExecAddColumn(List **wqueue, AlteredTableInfo *tab, Relation rel,
 				ereport(ERROR,
 						errcode(ERRCODE_PROGRAM_LIMIT_EXCEEDED),
 						errmsg("too many inheritance parents"));
-			CatalogTupleUpdate(attrdesc, &tuple->t_self, tuple);
 
+			HeapTupleMarkColumnUpdated(pg_attribute, attinhcount, updated);
+
+			CatalogTupleUpdate(attrdesc, &tuple->t_self, tuple, updated, NULL);
+
+			bms_free(updated);
+			updated = NULL;
 			heap_freetuple(tuple);
 
 			/* Inform the user about the merge */
@@ -7422,9 +7443,10 @@ ATExecAddColumn(List **wqueue, AlteredTableInfo *tab, Relation rel,
 	/*
 	 * Update pg_class tuple as appropriate
 	 */
-	relform->relnatts = newattnum;
-
-	CatalogTupleUpdate(pgclass, &reltup->t_self, reltup);
+	Assert(bms_is_empty(updated));
+	HeapTupleUpdateField(pg_class, relnatts, newattnum, relform, updated);
+	CatalogTupleUpdate(pgclass, &reltup->t_self, reltup, updated, NULL);
+	bms_free(updated);
 
 	heap_freetuple(reltup);
 
@@ -7888,6 +7910,7 @@ set_attnotnull(List **wqueue, Relation rel, AttrNumber attnum,
 	{
 		Relation	attr_rel;
 		HeapTuple	tuple;
+		Bitmapset  *updated = NULL;
 
 		attr_rel = table_open(AttributeRelationId, RowExclusiveLock);
 
@@ -7901,8 +7924,9 @@ set_attnotnull(List **wqueue, Relation rel, AttrNumber attnum,
 
 		attr = (Form_pg_attribute) GETSTRUCT(tuple);
 
-		attr->attnotnull = true;
-		CatalogTupleUpdate(attr_rel, &tuple->t_self, tuple);
+		HeapTupleUpdateField(pg_attribute, attnotnull, true, attr, updated);
+		CatalogTupleUpdate(attr_rel, &tuple->t_self, tuple, updated, NULL);
+		bms_free(updated);
 
 		/*
 		 * If the nullness isn't already proven by validated constraints, have
@@ -7981,6 +8005,7 @@ ATExecSetNotNull(List **wqueue, Relation rel, char *conName, char *colName,
 	{
 		Form_pg_constraint conForm = (Form_pg_constraint) GETSTRUCT(tuple);
 		bool		changed = false;
+		Bitmapset  *updated = NULL;
 
 		/*
 		 * Don't let a NO INHERIT constraint be changed into inherit.
@@ -8004,11 +8029,12 @@ ATExecSetNotNull(List **wqueue, Relation rel, char *conName, char *colName,
 				ereport(ERROR,
 						errcode(ERRCODE_PROGRAM_LIMIT_EXCEEDED),
 						errmsg("too many inheritance parents"));
+			HeapTupleMarkColumnUpdated(pg_constraint, coninhcount, updated);
 			changed = true;
 		}
 		else if (!conForm->conislocal)
 		{
-			conForm->conislocal = true;
+			HeapTupleUpdateField(pg_constraint, conislocal, true, conForm, updated);
 			changed = true;
 		}
 		else if (!conForm->convalidated)
@@ -8027,7 +8053,8 @@ ATExecSetNotNull(List **wqueue, Relation rel, char *conName, char *colName,
 
 			constr_rel = table_open(ConstraintRelationId, RowExclusiveLock);
 
-			CatalogTupleUpdate(constr_rel, &tuple->t_self, tuple);
+			CatalogTupleUpdate(constr_rel, &tuple->t_self, tuple, updated, NULL);
+			bms_free(updated);
 			ObjectAddressSet(address, ConstraintRelationId, conForm->oid);
 			table_close(constr_rel, RowExclusiveLock);
 		}
@@ -8275,6 +8302,7 @@ ATExecAddIdentity(Relation rel, const char *colName,
 	AttrNumber	attnum;
 	ObjectAddress address;
 	ColumnDef  *cdef = castNode(ColumnDef, def);
+	Bitmapset  *updated = NULL;
 	bool		ispartitioned;
 
 	ispartitioned = (rel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE);
@@ -8355,8 +8383,9 @@ ATExecAddIdentity(Relation rel, const char *colName,
 				 errmsg("column \"%s\" of relation \"%s\" already has a default value",
 						colName, RelationGetRelationName(rel))));
 
-	attTup->attidentity = cdef->identity;
-	CatalogTupleUpdate(attrelation, &tuple->t_self, tuple);
+	HeapTupleUpdateField(pg_attribute, attidentity, cdef->identity, attTup, updated);
+	CatalogTupleUpdate(attrelation, &tuple->t_self, tuple, updated, NULL);
+	bms_free(updated);
 
 	InvokeObjectPostAlterHook(RelationRelationId,
 							  RelationGetRelid(rel),
@@ -8469,8 +8498,11 @@ ATExecSetIdentity(Relation rel, const char *colName, Node *def,
 
 	if (generatedEl)
 	{
-		attTup->attidentity = defGetInt32(generatedEl);
-		CatalogTupleUpdate(attrelation, &tuple->t_self, tuple);
+		Bitmapset  *updated = NULL;
+
+		HeapTupleUpdateField(pg_attribute, attidentity, defGetInt32(generatedEl), attTup, updated);
+		CatalogTupleUpdate(attrelation, &tuple->t_self, tuple, updated, NULL);
+		bms_free(updated);
 
 		InvokeObjectPostAlterHook(RelationRelationId,
 								  RelationGetRelid(rel),
@@ -8525,6 +8557,7 @@ ATExecDropIdentity(Relation rel, const char *colName, bool missing_ok, LOCKMODE
 	Oid			seqid;
 	ObjectAddress seqaddress;
 	bool		ispartitioned;
+	Bitmapset  *updated = NULL;
 
 	ispartitioned = (rel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE);
 	if (ispartitioned && !recurse)
@@ -8573,8 +8606,9 @@ ATExecDropIdentity(Relation rel, const char *colName, bool missing_ok, LOCKMODE
 		}
 	}
 
-	attTup->attidentity = '\0';
-	CatalogTupleUpdate(attrelation, &tuple->t_self, tuple);
+	HeapTupleUpdateField(pg_attribute, attidentity, '\0', attTup, updated);
+	CatalogTupleUpdate(attrelation, &tuple->t_self, tuple, updated, NULL);
+	bms_free(updated);
 
 	InvokeObjectPostAlterHook(RelationRelationId,
 							  RelationGetRelid(rel),
@@ -8836,6 +8870,7 @@ ATExecDropExpression(Relation rel, const char *colName, bool missing_ok, LOCKMOD
 	Relation	attrelation;
 	Oid			attrdefoid;
 	ObjectAddress address;
+	Bitmapset  *updated = NULL;
 
 	attrelation = table_open(AttributeRelationId, RowExclusiveLock);
 	tuple = SearchSysCacheCopyAttName(RelationGetRelid(rel), colName);
@@ -8889,8 +8924,9 @@ ATExecDropExpression(Relation rel, const char *colName, bool missing_ok, LOCKMOD
 	 * Mark the column as no longer generated.  (The atthasdef flag needs to
 	 * get cleared too, but RemoveAttrDefault will handle that.)
 	 */
-	attTup->attgenerated = '\0';
-	CatalogTupleUpdate(attrelation, &tuple->t_self, tuple);
+	HeapTupleUpdateField(pg_attribute, attgenerated, '\0', attTup, updated);
+	CatalogTupleUpdate(attrelation, &tuple->t_self, tuple, updated, NULL);
+	bms_free(updated);
 
 	InvokeObjectPostAlterHook(RelationRelationId,
 							  RelationGetRelid(rel),
@@ -8942,9 +8978,9 @@ ATExecSetStatistics(Relation rel, const char *colName, int16 colNum, Node *newVa
 	Form_pg_attribute attrtuple;
 	AttrNumber	attnum;
 	ObjectAddress address;
-	Datum		repl_val[Natts_pg_attribute];
-	bool		repl_null[Natts_pg_attribute];
-	bool		repl_repl[Natts_pg_attribute];
+	Datum		values[Natts_pg_attribute] = {0};
+	bool		nulls[Natts_pg_attribute] = {false};
+	Bitmapset  *updated = NULL;
 
 	/*
 	 * We allow referencing columns by numbers only for indexes, since table
@@ -9047,16 +9083,14 @@ ATExecSetStatistics(Relation rel, const char *colName, int16 colNum, Node *newVa
 	}
 
 	/* Build new tuple. */
-	memset(repl_null, false, sizeof(repl_null));
-	memset(repl_repl, false, sizeof(repl_repl));
 	if (!newtarget_default)
-		repl_val[Anum_pg_attribute_attstattarget - 1] = Int16GetDatum(newtarget);
+		HeapTupleUpdateValue(pg_attribute, attstattarget, Int16GetDatum(newtarget), values, nulls, updated);
 	else
-		repl_null[Anum_pg_attribute_attstattarget - 1] = true;
-	repl_repl[Anum_pg_attribute_attstattarget - 1] = true;
-	newtuple = heap_modify_tuple(tuple, RelationGetDescr(attrelation),
-								 repl_val, repl_null, repl_repl);
-	CatalogTupleUpdate(attrelation, &tuple->t_self, newtuple);
+		HeapTupleUpdateValueNull(pg_attribute, attstattarget, values, nulls, updated);
+	newtuple = heap_update_tuple(tuple, RelationGetDescr(attrelation),
+								 values, nulls, updated);
+	CatalogTupleUpdate(attrelation, &tuple->t_self, newtuple, updated, NULL);
+	bms_free(updated);
 
 	InvokeObjectPostAlterHook(RelationRelationId,
 							  RelationGetRelid(rel),
@@ -9089,9 +9123,9 @@ ATExecSetOptions(Relation rel, const char *colName, Node *options,
 				newOptions;
 	bool		isnull;
 	ObjectAddress address;
-	Datum		repl_val[Natts_pg_attribute];
-	bool		repl_null[Natts_pg_attribute];
-	bool		repl_repl[Natts_pg_attribute];
+	Datum		values[Natts_pg_attribute] = {0};
+	bool		nulls[Natts_pg_attribute] = {false};
+	Bitmapset  *updated = NULL;
 
 	attrelation = table_open(AttributeRelationId, RowExclusiveLock);
 
@@ -9121,18 +9155,17 @@ ATExecSetOptions(Relation rel, const char *colName, Node *options,
 	(void) attribute_reloptions(newOptions, true);
 
 	/* Build new tuple. */
-	memset(repl_null, false, sizeof(repl_null));
-	memset(repl_repl, false, sizeof(repl_repl));
 	if (newOptions != (Datum) 0)
-		repl_val[Anum_pg_attribute_attoptions - 1] = newOptions;
+		HeapTupleUpdateValue(pg_attribute, attoptions, newOptions, values, nulls, updated);
 	else
-		repl_null[Anum_pg_attribute_attoptions - 1] = true;
-	repl_repl[Anum_pg_attribute_attoptions - 1] = true;
-	newtuple = heap_modify_tuple(tuple, RelationGetDescr(attrelation),
-								 repl_val, repl_null, repl_repl);
+		HeapTupleUpdateValueNull(pg_attribute, attoptions, values, nulls, updated);
+
+	newtuple = heap_update_tuple(tuple, RelationGetDescr(attrelation),
+								 values, nulls, updated);
 
 	/* Update system catalog. */
-	CatalogTupleUpdate(attrelation, &newtuple->t_self, newtuple);
+	CatalogTupleUpdate(attrelation, &newtuple->t_self, newtuple, updated, NULL);
+	bms_free(updated);
 
 	InvokeObjectPostAlterHook(RelationRelationId,
 							  RelationGetRelid(rel),
@@ -9193,19 +9226,21 @@ SetIndexStorageProperties(Relation rel, Relation attrelation,
 		if (HeapTupleIsValid(tuple))
 		{
 			Form_pg_attribute attrtuple = (Form_pg_attribute) GETSTRUCT(tuple);
+			Bitmapset  *updated = NULL;
 
 			if (setstorage)
-				attrtuple->attstorage = newstorage;
+				HeapTupleUpdateField(pg_attribute, attstorage, newstorage, attrtuple, updated);
 
 			if (setcompression)
-				attrtuple->attcompression = newcompression;
+				HeapTupleUpdateField(pg_attribute, attcompression, newcompression, attrtuple, updated);
 
-			CatalogTupleUpdate(attrelation, &tuple->t_self, tuple);
+			CatalogTupleUpdate(attrelation, &tuple->t_self, tuple, updated, NULL);
 
 			InvokeObjectPostAlterHook(RelationRelationId,
 									  RelationGetRelid(rel),
 									  attrtuple->attnum);
 
+			bms_free(updated);
 			heap_freetuple(tuple);
 		}
 
@@ -9226,6 +9261,7 @@ ATExecSetStorage(Relation rel, const char *colName, Node *newValue, LOCKMODE loc
 	Form_pg_attribute attrtuple;
 	AttrNumber	attnum;
 	ObjectAddress address;
+	Bitmapset  *updated = NULL;
 
 	attrelation = table_open(AttributeRelationId, RowExclusiveLock);
 
@@ -9245,9 +9281,9 @@ ATExecSetStorage(Relation rel, const char *colName, Node *newValue, LOCKMODE loc
 				 errmsg("cannot alter system column \"%s\"",
 						colName)));
 
-	attrtuple->attstorage = GetAttributeStorage(attrtuple->atttypid, strVal(newValue));
+	HeapTupleUpdateField(pg_attribute, attstorage, GetAttributeStorage(attrtuple->atttypid, strVal(newValue)), attrtuple, updated);
 
-	CatalogTupleUpdate(attrelation, &tuple->t_self, tuple);
+	CatalogTupleUpdate(attrelation, &tuple->t_self, tuple, updated, NULL);
 
 	InvokeObjectPostAlterHook(RelationRelationId,
 							  RelationGetRelid(rel),
@@ -9262,6 +9298,7 @@ ATExecSetStorage(Relation rel, const char *colName, Node *newValue, LOCKMODE loc
 							  false, 0,
 							  lockmode);
 
+	bms_free(updated);
 	heap_freetuple(tuple);
 
 	table_close(attrelation, RowExclusiveLock);
@@ -9455,9 +9492,11 @@ ATExecDropColumn(List **wqueue, Relation rel, const char *colName,
 				else
 				{
 					/* Child column must survive my deletion */
-					childatt->attinhcount--;
+					Bitmapset  *updated = NULL;
 
-					CatalogTupleUpdate(attr_rel, &tuple->t_self, tuple);
+					HeapTupleUpdateField(pg_attribute, attinhcount, childatt->attinhcount - 1, childatt, updated);
+					CatalogTupleUpdate(attr_rel, &tuple->t_self, tuple, updated, NULL);
+					bms_free(updated);
 
 					/* Make update visible */
 					CommandCounterIncrement();
@@ -9470,10 +9509,12 @@ ATExecDropColumn(List **wqueue, Relation rel, const char *colName,
 				 * we need to mark the inheritors' attributes as locally
 				 * defined rather than inherited.
 				 */
-				childatt->attinhcount--;
-				childatt->attislocal = true;
+				Bitmapset  *updated = NULL;
 
-				CatalogTupleUpdate(attr_rel, &tuple->t_self, tuple);
+				HeapTupleUpdateField(pg_attribute, attinhcount, childatt->attinhcount - 1, childatt, updated);
+				HeapTupleUpdateField(pg_attribute, attislocal, true, childatt, updated);
+				CatalogTupleUpdate(attr_rel, &tuple->t_self, tuple, updated, NULL);
+				bms_free(updated);
 
 				/* Make update visible */
 				CommandCounterIncrement();
@@ -12686,16 +12727,22 @@ ATExecAlterConstrInheritability(List **wqueue, ATAlterConstraint *cmdcon,
 		{
 			HeapTuple	childtup;
 			Form_pg_constraint childcon;
+			Bitmapset  *updated = NULL;
 
 			childtup = findNotNullConstraint(childoid, colName);
 			if (!childtup)
 				elog(ERROR, "cache lookup failed for not-null constraint on column \"%s\" of relation %u",
 					 colName, childoid);
+
 			childcon = (Form_pg_constraint) GETSTRUCT(childtup);
 			Assert(childcon->coninhcount > 0);
-			childcon->coninhcount--;
-			childcon->conislocal = true;
-			CatalogTupleUpdate(conrel, &childtup->t_self, childtup);
+
+			HeapTupleUpdateField(pg_constraint, coninhcount, childcon->coninhcount - 1, childcon, updated);
+			HeapTupleUpdateField(pg_constraint, conislocal, true, childcon, updated);
+
+			CatalogTupleUpdate(conrel, &childtup->t_self, childtup, updated, NULL);
+
+			bms_free(updated);
 			heap_freetuple(childtup);
 		}
 		else
@@ -12740,6 +12787,7 @@ AlterConstrTriggerDeferrability(Oid conoid, Relation tgrel, Relation rel,
 		Form_pg_trigger tgform = (Form_pg_trigger) GETSTRUCT(tgtuple);
 		Form_pg_trigger copy_tg;
 		HeapTuple	tgCopyTuple;
+		Bitmapset  *updated = NULL;
 
 		/*
 		 * Remember OIDs of other relation(s) involved in FK constraint.
@@ -12766,12 +12814,14 @@ AlterConstrTriggerDeferrability(Oid conoid, Relation tgrel, Relation rel,
 		tgCopyTuple = heap_copytuple(tgtuple);
 		copy_tg = (Form_pg_trigger) GETSTRUCT(tgCopyTuple);
 
-		copy_tg->tgdeferrable = deferrable;
-		copy_tg->tginitdeferred = initdeferred;
-		CatalogTupleUpdate(tgrel, &tgCopyTuple->t_self, tgCopyTuple);
+		HeapTupleUpdateField(pg_trigger, tgdeferrable, deferrable, copy_tg, updated);
+		HeapTupleUpdateField(pg_trigger, tginitdeferred, initdeferred, copy_tg, updated);
+
+		CatalogTupleUpdate(tgrel, &tgCopyTuple->t_self, tgCopyTuple, updated, NULL);
 
 		InvokeObjectPostAlterHook(TriggerRelationId, tgform->oid, 0);
 
+		bms_free(updated);
 		heap_freetuple(tgCopyTuple);
 	}
 
@@ -12886,6 +12936,7 @@ AlterConstrUpdateConstraintEntry(ATAlterConstraint *cmdcon, Relation conrel,
 {
 	HeapTuple	copyTuple;
 	Form_pg_constraint copy_con;
+	Bitmapset  *updated = NULL;
 
 	Assert(cmdcon->alterEnforceability || cmdcon->alterDeferrability ||
 		   cmdcon->alterInheritability);
@@ -12895,7 +12946,7 @@ AlterConstrUpdateConstraintEntry(ATAlterConstraint *cmdcon, Relation conrel,
 
 	if (cmdcon->alterEnforceability)
 	{
-		copy_con->conenforced = cmdcon->is_enforced;
+		HeapTupleUpdateField(pg_constraint, conenforced, cmdcon->is_enforced, copy_con, updated);
 
 		/*
 		 * NB: The convalidated status is irrelevant when the constraint is
@@ -12904,22 +12955,26 @@ AlterConstrUpdateConstraintEntry(ATAlterConstraint *cmdcon, Relation conrel,
 		 * ENFORCED, validation will be performed during phase 3, so it makes
 		 * sense to mark it as valid in that case.
 		 */
-		copy_con->convalidated = cmdcon->is_enforced;
+		HeapTupleUpdateField(pg_constraint, convalidated, cmdcon->is_enforced, copy_con, updated);
 	}
+
 	if (cmdcon->alterDeferrability)
 	{
-		copy_con->condeferrable = cmdcon->deferrable;
-		copy_con->condeferred = cmdcon->initdeferred;
+		HeapTupleUpdateField(pg_constraint, condeferrable, cmdcon->deferrable, copy_con, updated);
+		HeapTupleUpdateField(pg_constraint, condeferred, cmdcon->initdeferred, copy_con, updated);
 	}
+
 	if (cmdcon->alterInheritability)
-		copy_con->connoinherit = cmdcon->noinherit;
+		HeapTupleUpdateField(pg_constraint, connoinherit, cmdcon->noinherit, copy_con, updated);
+
+	CatalogTupleUpdate(conrel, &copyTuple->t_self, copyTuple, updated, NULL);
 
-	CatalogTupleUpdate(conrel, &copyTuple->t_self, copyTuple);
 	InvokeObjectPostAlterHook(ConstraintRelationId, copy_con->oid, 0);
 
 	/* Make new constraint flags visible to others */
 	CacheInvalidateRelcacheByRelid(copy_con->conrelid);
 
+	bms_free(updated);
 	heap_freetuple(copyTuple);
 }
 
@@ -13032,6 +13087,7 @@ QueueFKConstraintValidation(List **wqueue, Relation conrel, Relation fkrel,
 	AlteredTableInfo *tab;
 	HeapTuple	copyTuple;
 	Form_pg_constraint copy_con;
+	Bitmapset  *updated = NULL;
 
 	con = (Form_pg_constraint) GETSTRUCT(contuple);
 	Assert(con->contype == CONSTRAINT_FOREIGN);
@@ -13128,11 +13184,14 @@ QueueFKConstraintValidation(List **wqueue, Relation conrel, Relation fkrel,
 	 */
 	copyTuple = heap_copytuple(contuple);
 	copy_con = (Form_pg_constraint) GETSTRUCT(copyTuple);
-	copy_con->convalidated = true;
-	CatalogTupleUpdate(conrel, &copyTuple->t_self, copyTuple);
+
+	HeapTupleUpdateField(pg_constraint, convalidated, true, copy_con, updated);
+
+	CatalogTupleUpdate(conrel, &copyTuple->t_self, copyTuple, updated, NULL);
 
 	InvokeObjectPostAlterHook(ConstraintRelationId, con->oid, 0);
 
+	bms_free(updated);
 	heap_freetuple(copyTuple);
 }
 
@@ -13158,6 +13217,7 @@ QueueCheckConstraintValidation(List **wqueue, Relation conrel, Relation rel,
 	NewConstraint *newcon;
 	Datum		val;
 	char	   *conbin;
+	Bitmapset  *updated = NULL;
 
 	con = (Form_pg_constraint) GETSTRUCT(contuple);
 	Assert(con->contype == CONSTRAINT_CHECK);
@@ -13231,11 +13291,14 @@ QueueCheckConstraintValidation(List **wqueue, Relation conrel, Relation rel,
 	 */
 	copyTuple = heap_copytuple(contuple);
 	copy_con = (Form_pg_constraint) GETSTRUCT(copyTuple);
-	copy_con->convalidated = true;
-	CatalogTupleUpdate(conrel, &copyTuple->t_self, copyTuple);
+
+	HeapTupleUpdateField(pg_constraint, convalidated, true, copy_con, updated);
+
+	CatalogTupleUpdate(conrel, &copyTuple->t_self, copyTuple, updated, NULL);
 
 	InvokeObjectPostAlterHook(ConstraintRelationId, con->oid, 0);
 
+	bms_free(updated);
 	heap_freetuple(copyTuple);
 }
 
@@ -13258,6 +13321,7 @@ QueueNNConstraintValidation(List **wqueue, Relation conrel, Relation rel,
 	List	   *children = NIL;
 	AttrNumber	attnum;
 	char	   *colname;
+	Bitmapset  *updated = NULL;
 
 	con = (Form_pg_constraint) GETSTRUCT(contuple);
 	Assert(con->contype == CONSTRAINT_NOTNULL);
@@ -13334,11 +13398,14 @@ QueueNNConstraintValidation(List **wqueue, Relation conrel, Relation rel,
 	 */
 	copyTuple = heap_copytuple(contuple);
 	copy_con = (Form_pg_constraint) GETSTRUCT(copyTuple);
-	copy_con->convalidated = true;
-	CatalogTupleUpdate(conrel, &copyTuple->t_self, copyTuple);
+
+	HeapTupleUpdateField(pg_constraint, convalidated, true, copy_con, updated);
+
+	CatalogTupleUpdate(conrel, &copyTuple->t_self, copyTuple, updated, NULL);
 
 	InvokeObjectPostAlterHook(ConstraintRelationId, con->oid, 0);
 
+	bms_free(updated);
 	heap_freetuple(copyTuple);
 }
 
@@ -14213,8 +14280,11 @@ dropconstraint_internal(Relation rel, HeapTuple constraintTup, DropBehavior beha
 		/* All good -- reset attnotnull if needed */
 		if (attForm->attnotnull)
 		{
-			attForm->attnotnull = false;
-			CatalogTupleUpdate(attrel, &atttup->t_self, atttup);
+			Bitmapset  *updated = NULL;
+
+			HeapTupleUpdateField(pg_attribute, attnotnull, false, attForm, updated);
+			CatalogTupleUpdate(attrel, &atttup->t_self, atttup, updated, NULL);
+			bms_free(updated);
 		}
 
 		table_close(attrel, RowExclusiveLock);
@@ -14347,11 +14417,16 @@ dropconstraint_internal(Relation rel, HeapTuple constraintTup, DropBehavior beha
 			else
 			{
 				/* Child constraint must survive my deletion */
-				childcon->coninhcount--;
-				CatalogTupleUpdate(conrel, &tuple->t_self, tuple);
+				Bitmapset  *updated = NULL;
+
+				HeapTupleUpdateField(pg_constraint, coninhcount, childcon->coninhcount - 1, childcon, updated);
+
+				CatalogTupleUpdate(conrel, &tuple->t_self, tuple, updated, NULL);
 
 				/* Make update visible */
 				CommandCounterIncrement();
+
+				bms_free(updated);
 			}
 		}
 		else
@@ -14362,14 +14437,19 @@ dropconstraint_internal(Relation rel, HeapTuple constraintTup, DropBehavior beha
 			 * mark the inheritors' constraints as locally defined rather than
 			 * inherited.
 			 */
-			childcon->coninhcount--;
+			Bitmapset  *updated = NULL;
+
+			HeapTupleUpdateField(pg_constraint, coninhcount, childcon->coninhcount - 1, childcon, updated);
+
 			if (childcon->coninhcount == 0)
-				childcon->conislocal = true;
+				HeapTupleUpdateField(pg_constraint, conislocal, true, childcon, updated);
 
-			CatalogTupleUpdate(conrel, &tuple->t_self, tuple);
+			CatalogTupleUpdate(conrel, &tuple->t_self, tuple, updated, NULL);
 
 			/* Make update visible */
 			CommandCounterIncrement();
+
+			bms_free(updated);
 		}
 
 		heap_freetuple(tuple);
@@ -14775,6 +14855,7 @@ ATExecAlterColumnType(AlteredTableInfo *tab, Relation rel,
 	SysScanDesc scan;
 	HeapTuple	depTup;
 	ObjectAddress address;
+	Bitmapset  *updated = NULL;
 
 	/*
 	 * Clear all the missing values if we're rewriting the table, since this
@@ -14951,9 +15032,8 @@ ATExecAlterColumnType(AlteredTableInfo *tab, Relation rel,
 
 			int			one = 1;
 			bool		isNull;
-			Datum		valuesAtt[Natts_pg_attribute] = {0};
-			bool		nullsAtt[Natts_pg_attribute] = {0};
-			bool		replacesAtt[Natts_pg_attribute] = {0};
+			Datum		values[Natts_pg_attribute] = {0};
+			bool		nulls[Natts_pg_attribute] = {false};
 			HeapTuple	newTup;
 
 			missingval = array_get_element(missingval,
@@ -14971,35 +15051,36 @@ ATExecAlterColumnType(AlteredTableInfo *tab, Relation rel,
 														 tform->typbyval,
 														 tform->typalign));
 
-			valuesAtt[Anum_pg_attribute_attmissingval - 1] = missingval;
-			replacesAtt[Anum_pg_attribute_attmissingval - 1] = true;
-			nullsAtt[Anum_pg_attribute_attmissingval - 1] = false;
+			HeapTupleUpdateValue(pg_attribute, attmissingval, missingval, values, nulls, updated);
 
-			newTup = heap_modify_tuple(heapTup, RelationGetDescr(attrelation),
-									   valuesAtt, nullsAtt, replacesAtt);
+			newTup = heap_update_tuple(heapTup, RelationGetDescr(attrelation),
+									   values, nulls, updated);
 			heap_freetuple(heapTup);
+			bms_free(updated);
+			updated = NULL;
+
 			heapTup = newTup;
 			attTup = (Form_pg_attribute) GETSTRUCT(heapTup);
 		}
 	}
 
-	attTup->atttypid = targettype;
-	attTup->atttypmod = targettypmod;
-	attTup->attcollation = targetcollid;
+	HeapTupleUpdateField(pg_attribute, atttypid, targettype, attTup, updated);
+	HeapTupleUpdateField(pg_attribute, atttypmod, targettypmod, attTup, updated);
+	HeapTupleUpdateField(pg_attribute, attcollation, targetcollid, attTup, updated);
 	if (list_length(typeName->arrayBounds) > PG_INT16_MAX)
 		ereport(ERROR,
 				errcode(ERRCODE_PROGRAM_LIMIT_EXCEEDED),
 				errmsg("too many array dimensions"));
-	attTup->attndims = list_length(typeName->arrayBounds);
-	attTup->attlen = tform->typlen;
-	attTup->attbyval = tform->typbyval;
-	attTup->attalign = tform->typalign;
-	attTup->attstorage = tform->typstorage;
-	attTup->attcompression = InvalidCompressionMethod;
+	HeapTupleUpdateField(pg_attribute, attndims, list_length(typeName->arrayBounds), attTup, updated);
+	HeapTupleUpdateField(pg_attribute, attlen, tform->typlen, attTup, updated);
+	HeapTupleUpdateField(pg_attribute, attbyval, tform->typbyval, attTup, updated);
+	HeapTupleUpdateField(pg_attribute, attalign, tform->typalign, attTup, updated);
+	HeapTupleUpdateField(pg_attribute, attstorage, tform->typstorage, attTup, updated);
+	HeapTupleUpdateField(pg_attribute, attcompression, InvalidCompressionMethod, attTup, updated);
 
 	ReleaseSysCache(typeTuple);
 
-	CatalogTupleUpdate(attrelation, &heapTup->t_self, heapTup);
+	CatalogTupleUpdate(attrelation, &heapTup->t_self, heapTup, updated, NULL);
 
 	table_close(attrelation, RowExclusiveLock);
 
@@ -15059,6 +15140,7 @@ ATExecAlterColumnType(AlteredTableInfo *tab, Relation rel,
 						RelationGetRelid(rel), attnum);
 
 	/* Cleanup */
+	bms_free(updated);
 	heap_freetuple(heapTup);
 
 	return address;
@@ -15994,9 +16076,9 @@ ATExecAlterColumnGenericOptions(Relation rel,
 	HeapTuple	tuple;
 	HeapTuple	newtuple;
 	bool		isnull;
-	Datum		repl_val[Natts_pg_attribute];
-	bool		repl_null[Natts_pg_attribute];
-	bool		repl_repl[Natts_pg_attribute];
+	Datum		values[Natts_pg_attribute] = {0};
+	bool		nulls[Natts_pg_attribute] = {false};
+	Bitmapset  *updated = NULL;
 	Datum		datum;
 	Form_pg_foreign_table fttableform;
 	Form_pg_attribute atttableform;
@@ -16038,11 +16120,6 @@ ATExecAlterColumnGenericOptions(Relation rel,
 				 errmsg("cannot alter system column \"%s\"", colName)));
 
 
-	/* Initialize buffers for new tuple values */
-	memset(repl_val, 0, sizeof(repl_val));
-	memset(repl_null, false, sizeof(repl_null));
-	memset(repl_repl, false, sizeof(repl_repl));
-
 	/* Extract the current options */
 	datum = SysCacheGetAttr(ATTNAME,
 							tuple,
@@ -16058,18 +16135,15 @@ ATExecAlterColumnGenericOptions(Relation rel,
 									fdw->fdwvalidator);
 
 	if (DatumGetPointer(datum) != NULL)
-		repl_val[Anum_pg_attribute_attfdwoptions - 1] = datum;
+		HeapTupleUpdateValue(pg_attribute, attfdwoptions, datum, values, nulls, updated);
 	else
-		repl_null[Anum_pg_attribute_attfdwoptions - 1] = true;
-
-	repl_repl[Anum_pg_attribute_attfdwoptions - 1] = true;
+		HeapTupleUpdateValueNull(pg_attribute, attfdwoptions, values, nulls, updated);
 
 	/* Everything looks good - update the tuple */
+	newtuple = heap_update_tuple(tuple, RelationGetDescr(attrel),
+								 values, nulls, updated);
 
-	newtuple = heap_modify_tuple(tuple, RelationGetDescr(attrel),
-								 repl_val, repl_null, repl_repl);
-
-	CatalogTupleUpdate(attrel, &newtuple->t_self, newtuple);
+	CatalogTupleUpdate(attrel, &newtuple->t_self, newtuple, updated, NULL);
 
 	InvokeObjectPostAlterHook(RelationRelationId,
 							  RelationGetRelid(rel),
@@ -16081,6 +16155,7 @@ ATExecAlterColumnGenericOptions(Relation rel,
 
 	table_close(attrel, RowExclusiveLock);
 
+	bms_free(updated);
 	heap_freetuple(newtuple);
 
 	return address;
@@ -16207,13 +16282,13 @@ ATExecChangeOwner(Oid relationOid, Oid newOwnerId, bool recursing, LOCKMODE lock
 	 */
 	if (tuple_class->relowner != newOwnerId)
 	{
-		Datum		repl_val[Natts_pg_class];
-		bool		repl_null[Natts_pg_class];
-		bool		repl_repl[Natts_pg_class];
+		Datum		values[Natts_pg_class] = {0};
+		bool		nulls[Natts_pg_class] = {false};
 		Acl		   *newAcl;
 		Datum		aclDatum;
 		bool		isNull;
 		HeapTuple	newtuple;
+		Bitmapset  *updated = NULL;
 
 		/* skip permission checks when recursing to index or toast table */
 		if (!recursing)
